use crate::mesh::{
    Quad,
    QuadGroups,
};

#[derive(Debug, Clone, Copy, PartialEq, Eq)]
pub enum Visibility {
    Empty,
    Opaque,
    Transparent,
}

pub const EMPTY: Visibility = Visibility::Empty;
pub const OPAQUE: Visibility = Visibility::Opaque;
pub const TRANSPARENT: Visibility = Visibility::Transparent;

pub trait Voxel: Eq {
    fn visibility(&self) -> Visibility;

    #[inline]
    fn mesh(buffer: &mut QuadGroups, index: usize, x: usize, y: usize, z: usize) {
        buffer.groups[index].push(Quad { voxel: [x, y, z] });
    }
}
